#!/bin/sh
malia=arm64
malig=aarch64-linux-gnu
malil=meson_gx_mali_450
malim=mali450
malis=meson
maliv=r7p0

eglplat=$1

if [ "X${eglplat}" == "X" ]; then
  eglplat=-x11
fi

sl="libEGL.so.1.0.0
libGLESv1_CM.so.1.1.0
libGLESv2.so.2.0.0"

sl="${sl}
libGLdispatch.so.0.0.0
libGL.so.1.0.0
libGLU.so.1.3.1
libGLX.so.0.0.0
libOpenGL.so.0.0.0"

sl="${sl}
libwayland-egl.so.1.0.0"

sl="${sl}
libgbm.so.1.0.0"

apt-get install -y quilt

if [ ! -e include ]; then
  tar xzf mali450-meson-dev.tar.gz

  if [ ! -e include/EGL_platform/platform_${eglplat:1} ]; then
    exit 1
  fi

  cp -p include/EGL_platform/platform_${eglplat:1}/*.h  include/EGL/

  cat patches/series-mali-r7p0-dev >> patches/series
  quilt push -a
fi

if [ ! -e include/EGL_platform/platform_${eglplat:1} ]; then
  exit 1
fi

echo ${eglplat:1}

for d in EGL GLES GLES2 GLES3 KHR ; do
  if [ -e /usr/include/${d} -a ! -e /usr/include/${d}.backup ]; then
    mv /usr/include/${d} /usr/include/${d}.backup
  fi

  mkdir -p /usr/include/${d}
  cp -apP include/${d}/. /usr/include/${d}/
done

rm -rf include/
rm -rf .pc/
rm -f patches/series

for f in egl.pc glesv1.pc glesv1_cm.pc glesv2.pc wayland-egl.pc ; do
  if [ -e lib/pkgconfig/$f -a ! -e  /usr/lib/${malig}/pkgconfig/$f ]; then
    mkdir -p /usr/lib/${malig}/pkgconfig
    cp -p lib/pkgconfig/$f /usr/lib/${malig}/pkgconfig/
  fi

  if [ -e /usr/lib/${malig}/pkgconfig/$f ]; then
    if grep -q -E '^Version: r.p.' /usr/lib/${malig}/pkgconfig/$f ; then
      sed -i s/'^Version: r.p.'/'Version: 17.2.2'/g /usr/lib/${malig}/pkgconfig/$f
    fi
    if grep -q -E '^Version: 0.99' /usr/lib/${malig}/pkgconfig/$f ; then
      sed -i s/'^Version: 0.99'/'Version: 17.2.2'/g /usr/lib/${malig}/pkgconfig/$f
    fi
  fi
done

if [ ! -e /usr/lib/${malig}/libEGL.so ]; then
  apt-get install -y libegl1-dev  || apt-get install -y libegl1-mesa-dev
fi

if [ ! -e /usr/lib/${malig}/libGLESv2.so ]; then
  apt-get install -y libgles2-dev || apt-get install -y libgles2-mesa-dev
fi

if [ ! -e /usr/lib/${malig}/libGL.so ]; then
  apt-get install -y libgl1-dev   || apt-get install -y libgl1-mesa-dev
fi

if [ ! -e /usr/lib/${malig}/libGLU.so ]; then
  apt-get install -y libglu1-dev || apt-get install -y libglu1-mesa-dev
fi

if [ ! -e /usr/lib/${malig}/libgbm.so ]; then
  apt-get install -y libgbm-dev
fi

for o in ${sl} ; do
  s=$o
  a=`echo ${s} | cut -d . -f 1-2`
  b=`echo ${s} | cut -d . -f 1`

  if [ ! -e /usr/lib/${malig}/${s} ]; then
    for f in /usr/lib/${malig}/${b}.*.* ; do
      if [ -e ${f} ]; then
        s=`basename $f`
      fi
    done
  fi

  if [ ! -e /usr/lib/${malig}/${a} ]; then
    if [ -e /usr/lib/${malig}/${s} ]; then
      echo Using ${s} for ${a}
      rm -f /usr/lib/${malig}/${a}
      ln -s ${s} /usr/lib/${malig}/${a}
    fi
  fi
done

echo OK

